<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:p="http://primefaces.org/ui"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                template="/WEB-INF/templates/LoggedTemplate.xhtml">       

    <ui:define name="contentPart">

        <h:outputText value="RH -> Plazas -> Agregar Plaza" 
                      style="font-weight: bold; font-size: medium"/>

        <hr class="ui-separator ui-state-default ui-corner-all separator"></hr>
        <h:outputText value="Creación de plazas" />
        <br/>

        <h:form id="addPlazaForm">

            <h:panelGrid 
                id="busquedaPanelGridId" 
                columns="2" 
                >

                <br/><br/>

                <h:panelGrid 
                    columns="4" 
                    columnClasses="centered5,centered6,centered5,centered6"
                    style="width:100%; text-align:left; padding-left: 90px " 
                    cellpadding="10px" 
                    id="creaPlaza1" >
                    <f:facet name="header">
                        Agregar Nueva Plaza:
                    </f:facet>
                    <p:row>
                        <h:outputLabel 
                            for="acAdscripcion" 
                            value="#{translatedMessage['restricted.rh.plaza.adscripciones']}: * "
                            style=" font-weight:bold"/>
                    </p:row>
                    <p:row>
                        <p:autoComplete 
                            id="acAdscripcion"
                            value="#{addPlazaMB.plazaSelected.rhNomnAdscripcionesTO}"                                    
                            maxResults="6"
                            completeMethod="#{addPlazaMB.completeText}"
                            var="adscripcionQ" 
                            minQueryLength="1"                                     
                            itemLabel="#{addPlazaMB.llenaAutoCompliteInput(adscripcionQ)}"
                            itemValue="#{adscripcionQ}" 
                            converter="adscripcionConverter" 
                            size="25"
                            forceSelection="true"
                            >

                            <p:ajax 
                                event="itemSelect" 
                                update="tabulador, unidadAdm"
                                process="@this" 
                                listener="#{addPlazaMB.actualizarTabuladores(addPlazaMB.plazaSelected.rhNomnAdscripcionesTO.claveAdscripcion)}" />                                                    

                        </p:autoComplete>
                    </p:row>
                    <p:row>
                        <h:outputLabel 
                            for="tabulador" 
                            value="#{translatedMessage['restricted.rh.plaza.tabuladores']}: * "
                            style=" font-weight:bold"/>
                    </p:row>
                    <p:row>
                        <p:selectOneMenu 
                            id="tabulador" 
                            value="#{addPlazaMB.plazaSelected.rhNomnTabuladoresTO}" 
                            converter="entityConverter"
                            filter="true"
                            autoWidth="false"
                            filterMatchMode="contains" 
                            caseSensitive="false" 
                            style="width: 150px"> 

                            <f:selectItem 
                                itemLabel="Selecciona una opción..."/>                        

                            <f:selectItems 
                                value="#{addPlazaMB.listadoTabuladores}"
                                var="tabuladores"
                                itemLabel="#{tabuladores.strClaveTabulador}"
                                itemValue="#{tabuladores}"/>

                            <p:ajax 
                                event="change" 
                                update="puesto" 
                                listener="#{addPlazaMB.actualizarPuesto(addPlazaMB.plazaSelected.rhNomnTabuladoresTO.grupoJerarquico.strClaveJerarquica, addPlazaMB.plazaSelected.rhNomnAdscripcionesTO.claveAdscripcion)}" />
                        </p:selectOneMenu>   
                    </p:row>
                    <p:row>
                        <h:outputLabel 
                            for="puesto" 
                            value="#{translatedMessage['restricted.rh.plaza.puestos']}: * "
                            style=" font-weight:bold"/>
                    </p:row>
                    <p:row>
                        <p:selectOneMenu 
                            id="puesto" 
                            value="#{addPlazaMB.plazaSelected.puestoTO}" 
                            converter="entityConverter"
                            filter="true" 
                            autoWidth="false"
                            filterMatchMode="contains" 
                            caseSensitive="false" 
                            style="width: 150px">   

                            <f:selectItem 
                                itemLabel="Selecciona una opción..."/>                        

                            <f:selectItems 
                                value="#{addPlazaMB.listadoPuestos}"
                                var="puestos"
                                itemLabel="#{puestos.descripcion}"
                                itemValue="#{puestos}"/>
                        </p:selectOneMenu>     
                    </p:row>
                    <p:row>
                        <h:outputLabel 
                            for="estructura" 
                            value="#{translatedMessage['restricted.rh.plaza.estructuras']}: * "
                            style=" font-weight:bold"/>
                    </p:row>
                    <p:row>
                        <p:selectOneMenu 
                            id="estructura" 
                            value="#{addPlazaMB.plazaSelected.estructuraTO}" 
                            converter="entityConverter"
                            filter="true" 
                            autoWidth="false"
                            filterMatchMode="contains" 
                            caseSensitive="false" 
                            style="width: 150px"> 

                            <f:selectItem 
                                itemLabel="Selecciona una opción..."/>                        

                            <f:selectItems 
                                value="#{addPlazaMB.listadoEstructura}"
                                var="estructuras"
                                itemLabel="#{estructuras.descripcion}"
                                itemValue="#{estructuras}"/>                        
                        </p:selectOneMenu>    
                    </p:row>
                    <p:row>
                        <h:outputLabel 
                            for="tipoNombramiento" 
                            value="#{translatedMessage['restricted.rh.plaza.tiposNombramientos']}: * "
                            style=" font-weight:bold"/>
                    </p:row>
                    <p:row>
                        <p:selectOneMenu 
                            id="tipoNombramiento" 
                            value="#{addPlazaMB.plazaSelected.tipoNombramientoTO}" 
                            converter="entityConverter"
                            filter="true" 
                            autoWidth="false"
                            filterMatchMode="contains" 
                            caseSensitive="false" 
                            style="width: 150px">  

                            <f:selectItem 
                                itemLabel="Selecciona una opción..."/>                        

                            <f:selectItems 
                                value="#{addPlazaMB.listadoTipoNombramiento}"
                                var="tipoNombramientos"
                                itemLabel="#{tipoNombramientos.descripcion}"
                                itemValue="#{tipoNombramientos}"/>                        

                            <p:ajax 
                                process="@form" 
                                update="vigenciaFinalLabel, vigenciaFinalWrapper" 
                                event="change" 
                                listener="#{addPlazaMB.actualizaVigenciaFinalLabel}" />
                        </p:selectOneMenu> 
                    </p:row>
                    <p:row>
                        <h:outputLabel 
                            for="vigenciaInicio" 
                            value="#{translatedMessage['restricted.rh.plaza.vigenciaInicio']}: * "
                            style=" font-weight:bold"/>
                    </p:row>
                    <p:row>
                        <p:calendar                         
                            id="vigenciaInicio"                         
                            showOn="button"                                        
                            pattern="dd/MM/yyyy"
                            locale= "es"
                            style="width: 150px"
                            maxlength="10"
                            mode="popup"
                            navigator="true"
                            readonlyInput="true"
                            value="#{addPlazaMB.plazaSelected.vigenciaInicio}"
                            mindate="#{addPlazaMB.fechaMinimaSelected}"
                            maxdate="#{addPlazaMB.vigenciaFinalValidada}" 
                            converterMessage="Fecha incorrecta, el formato es dd/mm/yyyy"
                            >

                            <p:ajax 
                                event="dateSelect" 
                                update="vigenciaFinal" 
                                listener="#{addPlazaMB.validarVigencias}" />
                        </p:calendar>
                    </p:row>
                    <p:row>
                        <h:panelGroup id="vigenciaFinalWrapper">
                            <h:outputLabel 
                                id="vigenciaFinalLabel" 
                                for="vigenciaFinal" 
                                value="#{addPlazaMB.vigenciaFinalLabel}: "
                                style=" font-weight:bold"/>
                        </h:panelGroup>
                    </p:row>
                    <p:row>
                        <p:calendar 
                            value="#{addPlazaMB.plazaSelected.vigenciaFinal}"
                            id="vigenciaFinal" 
                            showOn="button"                                        
                            pattern="dd/MM/yyyy"
                            locale= "es"
                            style="width: 150px"
                            maxlength="10"
                            mode="popup"
                            navigator="true"
                            readonlyInput="true"
                            onkeydown="borrarCalendario(event)"
                            mindate="#{addPlazaMB.vigenciaInicioValidada}"   
                            maxdate="#{addPlazaMB.vigenciaFinalMaxValidada}"
                            converterMessage="Fecha incorrecta, el formato es dd/mm/yyyy">

                            <p:ajax 
                                event="dateSelect" 
                                update="vigenciaInicio" 
                                listener="#{addPlazaMB.validarVigencias}"/>                        
                        </p:calendar>
                    </p:row>

                </h:panelGrid>

                <p:row/>

                <h:panelGrid 
                    columns="2"  
                    columnClasses="centered2,centered,centered2,centered" 
                    style="width:100%; text-align:left; padding-left: 90px "  >                    

                    <p:row>
                        <h:outputLabel 
                            for="estatus" 
                            value="#{translatedMessage['restricted.rh.plaza.estatusPlaza']}: "
                            style=" font-weight:bold"/>

                        <h:outputText 
                            id="estatus"  
                            value="#{addPlazaMB.plazaSelected.estatusPlazaTO.descripcion}"/>                    
                    </p:row>

                    <p:row>
                        <h:outputLabel 
                            for="pef" 
                            value="#{translatedMessage['restricted.rh.plaza.pef']}: "
                            style=" font-weight:bold"/>

                        <h:outputText 
                            id="pef" 
                            value="SI"/>    
                    </p:row>

                    <p:row>
                        <h:outputLabel 
                            for="ejercicio" 
                            value="#{translatedMessage['restricted.rh.plaza.ejercicios']}: "
                            style=" font-weight:bold"/>

                        <h:outputText 
                            id="ejercicio" 
                            value="#{addPlazaMB.plazaSelected.ejercicioTO.valor}"/>                     
                    </p:row>

                    <p:row>
                        <h:outputLabel 
                            for="unidadAdm" 
                            value="#{translatedMessage['restricted.rh.plaza.unidadAministrativa']}: "
                            style=" font-weight:bold"/>                                            

                        <h:outputText 
                            id="unidadAdm" 
                            value="#{addPlazaMB.plazaSelected.rhNomnAdscripcionesTO.detalleunidadAdm.claveUniAdm}" />                    
                    </p:row>
                </h:panelGrid>

                <p:row/>

                <h:panelGrid columns="1"
                             style="width:100%; text-align:left; padding-left: 90px; "
                             cellpadding="5px"
                             columnClasses="centered7">                

                    <f:facet name="header">
                        #{translatedMessage['restricted.rh.plaza.comentario']}
                    </f:facet>
                    <p:row >
                        <p:inputText style="visibility: hidden; width: 200px"/>

                        <p:inputTextarea 
                            rows="5" 
                            cols="50" 
                            id="comentario" 
                            value="#{addPlazaMB.plazaSelected.comentario}" 
                            counter="display" 
                            maxlength="255" 
                            counterTemplate="{0} caracteres restantes del comentario." 
                            autoResize="false"  /> 
                    </p:row>
                    <p:row>
                        <p:inputText style="visibility: hidden; width: 200px"/>
                        <h:outputText id="display"/>
                    </p:row>
                </h:panelGrid>
            </h:panelGrid>

            <br/>
            <div align="right" style="padding-right: 16%">
                <p:commandButton
                    update=":addPlazaForm"
                    value="#{translatedMessage['common.label.create']}"
                    oncomplete="redirect(xhr, status, args, 'bandejaPlaza.jsf');"
                    actionListener="#{addPlazaMB.guardarPlaza}">
                </p:commandButton>
                <div style="width:5px;
                     height:auto;
                     display:inline-block;"/>
                <p:commandButton
                    value="Cerrar"
                    type="button"
                    onclick="location = 'bandejaPlaza.jsf';">
                </p:commandButton>

                <p:commandButton 
                    id="btnClearDF"                 
                    value="Limpia Vigencia Fin" 
                    actionListener="#{addPlazaMB.limpiaCampo()}"  
                    update="vigenciaFinal " 
                    process="@this vigenciaFinal" 
                    onclick="nada();" 
                    style="display: none"/>
            </div>
            <br/><br/>   
        </h:form>

        <script>
            function borrarCalendario(e) { // 1
                tecla = (document.all) ? e.keyCode : e.which; // 2

                if (tecla === 8 || tecla === 46) {
                    jQuery('[id*=btnClearDF]').trigger('click');
                }

                return true; // 3            
            }
            ;

            function nada() {
                console.log("nada");
            };
        </script>         
    </ui:define>

    <ui:define name="avisoExitoMsg">
        <h:outputText value="La Plaza se Agregó Correctamente"/>
    </ui:define>

    <ui:define name="avisoExitoDlg">
        <input 
            type="button" 
            value="Editar" 
            onclick="location = 'plazAdd.jsf';" />
    </ui:define>

    <ui:define name="outLayoutPart" >
        <ui:include src="/WEB-INF/components/Dialogs.xhtml" />
    </ui:define>        
</ui:composition>
